import fr.dgac.ivy.* ;
import gnu.getopt.*;

class Filter implements IvyBindListener {

  Ivy bus;

  public static void main(String[] args) throws IvyException {
    Getopt opt = new Getopt("Filter",args,"b:n:t:");
    String domain=Ivy.getDomain(null);
    int c;
    int nb = 10000;
    int t= 1000;
    while ((c = opt.getopt()) != -1) switch (c) {
    case 'b':
      domain=opt.getOptarg();
      break;
    case 't':
      t=Integer.parseInt(opt.getOptarg());
      break;
    case 'n':
      nb=Integer.parseInt(opt.getOptarg());
      break;
    default:
      System.exit(0);
    }
    new Filter(domain,nb,t);
  }

  private int recus = 0;
  private int nbmsg;
  private String[] filter = { "Dummy" };

  public Filter(String domain,int n,int t) throws IvyException {
    System.out.println("trying Filter on " + n + " messages, "+t+" ms delay");
    nbmsg=n;
    bus = new Ivy("Filter","Filter ready", null);
    bus.setFilter(filter);
    bus.addBindListener(this);
    bus.bindMsg("^coucou(.*)",new IvyMessageListener() {
      public void receive(IvyClient ic,String[] args) { }
    });
    bus.start(domain);
    System.out.println("coucou");
    for (int i=0;i<n;i++ ) {
      try {
	System.out.println("sending msg");
	bus.sendMsg("Dummy message");
	Thread.sleep(t);
      } catch (IvyException ie) { System.exit(-1); }
      catch (InterruptedException _) { }
    }
    bus.stop();
  }

  public void bindPerformed(IvyClient client,int id,String re) {
    System.out.println(client.getApplicationName() + " subscribes to " +re );
  }

  public void unbindPerformed(IvyClient client,int id,String re) {
    System.out.println(client.getApplicationName() + " unsubscribes to " +re );
  }

}
