/**
 * Another Ivy java library API tester: wait for client
 *
 * @author  Yannick Jestin <mailto:jestin@cena.fr>
 *
 * (c) CENA
 *
 * usage: java Request
 *
 * Changelog
 *   1.2.8 : first release
 *
 */
import fr.dgac.ivy.*;
import gnu.getopt.Getopt;

class WFC {

  private Ivy bus;
  static int serial = 0;
  private static final int NBCLIENTS = 3;

  public static void main(String[] args) throws IvyException {
    String domain=Ivy.getDomain(null);
    Getopt opt = new Getopt("WFC",args,"n:b:");
    int c;
    int n = NBCLIENTS;
    while ((c = opt.getopt()) != -1) switch (c) {
    case 'b': domain=opt.getOptarg(); break;
    case 'n': n=Integer.parseInt(opt.getOptarg());break;
    }
    new WFC(domain,n);
  }

  public WFC(String domain,int n) throws IvyException {
    IvyClient[] tab=new IvyClient[n];
    bus = new Ivy("WFCTest","WFCTest ready", null);
    /* bus.bindMsg("Client(.*) ready",new IvyMessageListener(){
      public void receive(IvyClient ic,String[] arg) {
	System.out.println("seen client "+arg[0]);
      }
    });
    */
    bus.start(domain);
    System.out.println("launching "+n+" clients");
    for (int i=0;i<n;i++) new Client(domain);
    System.out.println("waiting for them");
    for (int i=0;i<n;i++) {
      tab[i]=bus.waitForClient("Client"+i,5000);
      if (tab[i]==null) {
	System.out.println("can't find Client"+i+" after 5 seconds");
	i--; // one more time ... can loop forever
      }
    }
    System.out.println("sending them' a die message");
    for (int i=0;i<n;i++) tab[i].sendDie("bye bye");
    System.out.println("leaving the bus");
    bus.stop();
  }

  // this kind of Ivy Agent just comes and sits there
  private class Client {
    Ivy cbus;
    String name;
    public Client(String domain) throws IvyException {
      name = "Client"+serial++;
      cbus = new Ivy(name,name+" ready",null);
      cbus.start(domain);
    }
  }

}
